<template>
  <div id="show_employee_table">
    <div class="columns tabs">
      <div class="column tab1 details_tab newBtn" @click="toggleTab" v-bind:class="{ tapped: tab }">Details</div>
      <div class="column tab1 package_tab newBtn" @click="toggleTab" v-bind:class="{ tapped: !tab }">Package</div>
    </div>
    <div class="details" v-if="tab">
      <div class="columns mini_tab">
      <div class="profile_tab" @click="toggleProfileTab" v-bind:class="{ highlight: profileTab }">Profile</div><div class="pipe">|</div>
      <div class="account_tab" @click="toggleAccountTab" v-bind:class="{ highlight: accountTab }">Account</div>
      <div v-if='is_user === "true"'>
       <span class="pipe">|</span><span class="role_tab" @click="toggleRoleTab" v-bind:class="{ highlight: roleTab }">Role</span>
      </div>
    </div>
      <div id="profile" v-if="profileTab" >
        <div class="columns show_div">
          <div class="column col-3 show_label">Status</div>
          <div class="column col-4 show_field">{{this.value.status}}</div>
        </div>
        <div class="columns show_div grey_div">
          <div class="column col-3 show_label">Date of Birth</div>
          <div class="column col-4 show_field">{{this.value.dob}}</div>
        </div>
        <div class="columns show_div">
          <div class="column col-3 show_label">Gender</div>
          <div class="column col-4 show_field">{{this.value.gender}}</div>
        </div>
        <div class="columns show_div grey_div">
          <div class="column col-3 show_label">Marital Status</div>
          <div class="column col-4 show_field">{{this.value.marital_status}}</div>
        </div>
        <div class="columns show_div">
          <div class="column col-3 show_label">Email</div>
          <div class="column col-4 show_field">{{this.value.email}}</div>
        </div>
        <div class="columns show_div grey_div">
          <div class="column col-3 show_label">Phone Number</div>
          <div class="column col-4 show_field">{{this.value.phone}}</div>
        </div>
        <div class="columns show_div">
          <div class="column col-3 show_label">Address</div>
          <div class="column col-4 show_field">{{this.value.address}}</div>
        </div>
        <div class="columns show_div grey_div">
          <div class="column col-3 show_label">No. of Children</div>
          <div class="column col-4 show_field">{{this.value.children}}</div>
        </div>
        <div class="columns show_div">
          <div class="column col-3 show_label">No. of Dependents</div>
          <div class="column col-4 show_field">{{this.value.dependents}}</div>
        </div>
        <div class="button_div3 columns column col12">
            <div class="column col6 cancel_group" v-on:click="close" ><img src="images/icons/show_page_cancel.svg" alt="Cancel icon" class=""/><span class="icon_label">CANCEL</span></div>
            <div class="column col6  right_align edit_group" v-on:click="editEmployee"><img src="images/icons/show_page_edit.svg" alt="Edit icon" class=""/><span class="icon_label">EDIT</span></div>
        </div>
       </div>

      <div id="account" v-if="accountTab">
          <!-- Account tab info goes here -->
          <div class="new_account" v-if="!accountExists">
             <div class="column col6 edit_group" v-on:click="addAccount"><img src="images/icons/show_page_add.svg" alt="Add icon" class=""/><span class="icon_label">ADD</span></div>
          </div>
          <div class="existing__account" v-if="accountExists">
          <div class="columns show_div">
            <div class="column col-3 show_label">Account Name</div>
            <div class="column col-4 show_field">{{this.value.account_name}}</div>
          </div>
          <div class="columns show_div grey_div">
            <div class="column col-3 show_label">Account Number</div>
            <div class="column col-4 show_field">{{this.value.account_number}}</div>
          </div>
          <div class="columns show_div">
            <div class="column col-3 show_label">Sort Code</div>
            <div class="column col-4 show_field">{{this.value.sort_code}}</div>
          </div>
          <div class="columns show_div grey_div">
            <div class="column col-3 show_label">Bank Name</div>
            <div class="column col-4 show_field">{{this.value.bank_name}}</div>
          </div>
          <div class="columns show_div">
            <div class="column col-3 show_label">Branch Address</div>
            <div class="column col-4 show_field">{{this.value.branch_address}}</div>
          </div>
          <div class="columns show_div grey_div">
            <div class="column col-3 show_label">Country</div>
            <div class="column col-4 show_field">{{this.value.bank_country}}</div>
          </div>
        
        <div class="button_div3 columns column col12">
            <div class="column col6 cancel_group" v-on:click="close" ><img src="images/icons/show_page_cancel.svg" alt="Cancel icon" class=""/><span class="icon_label">CANCEL</span></div>
            <div class="column col6 right_align edit_group" v-on:click="editAccount"><img src="images/icons/show_page_edit.svg" alt="Edit icon" class=""/><span class="icon_label">EDIT</span></div>
        </div>
        </div>
      </div>

      <div v-if="roleTab">
       <!-- Account tab info goes here -->  
       <form id="role_form">             
          <div class="columns show_div">
            <div class="column col-3 show_label">HR</div>
            <div class="column col-4 show_field"><input type="radio" name="user[role]" value="HR"> </div>
          </div>
          <div class="columns show_div grey_div">
            <div class="column col-3 show_label">Employee</div>
            <div class="column col-4 show_field"><input type="radio" name="user[role]" value="Employee"> </div>
          </div>
          <div class="columns show_div">
            <div class="column col-3 show_label">Cashier</div>
            <div class="column col-4 show_field"><input type="radio" name="user[role]" value="Cashier"></div>
          </div>
          <div class="columns show_div grey_div">
            <div class="column col-3 show_label">Accountant</div>
            <div class="column col-4 show_field"><input type="radio" name="user[role]" value="Accountant"></div>
          </div>
          <div class="columns show_div">
            <div class="column col-3 show_label">Manager</div>
            <div class="column col-4 show_field"><input type="radio" name="user[role]" value="Manager"></div>
          </div>
          <input type="hidden" name="user[email]" v-model="email" >
                 
        <div class="button_div3 columns column col12">
            <div class="column col6 cancel_group" v-on:click="close" ><img src="images/icons/show_page_cancel.svg" alt="Cancel icon" class=""/><span class="icon_label">CANCEL</span></diV>
            <div class="column col6 right_align edit_group" v-on:click="submitRole"><img src="images/icons/show_page_edit.svg" alt="Submit icon" class=""/><span class="icon_label">SUBMIT</span></div>
        </div>
      </form>
      </div>

    </div>
    <div id="package" v-else>
      <!-- <div class="button_div">
        <button class="btn btn-package btn-position" v-if="showPackageButton" @click="showPackageTable">Use Package Template</button>
      </div> -->
      <Package @ :passedEarning="passedEarning" :employeeId = employeeId />
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Package from "./package.vue";
export default {
  name: "ShowEmployee",
  props: ["value", "enable_field", "display_4", "passedEarning", "accountUpdated"],

  data() {
    return {
      email: this.value.email,
      is_user: this.value.is_user,
      employeeId: parseInt(this.value.id),
      display_tag: false,
      disable_field: false,
      display1: true,
      display2: false,
      modal_display: true,
      currentEmployee: this.value,
      showPackageForm: false,
      tab: true,
      innerTab: true,
      frequency: "_",
      rate: "_",
      calculation: "_",
      start_date: "_",
      end_date: "_",
      showPackageButton: true,
      profileTab: true,
      accountTab: false,
      roleTab: false,
      accountExists: false

    };
  },
  components: {
    Package
  },
  methods: {
    briefDisplay() {
      setTimeout(function() {
        this.successful = false;
      }, 2000);
    },
    editEmployee() {
      this.display1 = true;
      this.display2 = false;
      this.$emit("submit", this.currentEmployee, this.display1, this.display2);
    },
    addAccount(){
        this.$emit("add_account");
    },
    editAccount(){
        this.$emit("edit_account");
    },
    close:function (event) {
      this.$emit("cancel");
    },
    modifyPackage(event) {
      event.preventDefault();
    },
    showPackageTable(event) {
      event.preventDefault();
      console.log("Work in progress!!!");
      this.$emit("select", this.modal_display);
      this.disable_field=true
      this.showPackageButton = false
    },
    togglePackageForm(event) {
      event.preventDefault();
     
    },
    temps(){
      this.display_4 = true
    },
    toggleTab() {
      this.tab = !this.tab;
    },
    toggleProfileTab(){
      this.profileTab  = true;
      this.accountTab  = false;
      this.roleTab  = false;
    },
    toggleAccountTab(){
      this.accountTab  = true;
      this.profileTab  = false;
      this.roleTab  = false;
    },
    toggleRoleTab(){
      this.roleTab  = true;
      this.profileTab  = false;
      this.accountTab  = false;
    },
    saveAsNew() {
      if (this.display_tag == false) {
        this.display_tag = true;
      } else {
        this.display_tag = false;
      }
    },
    submitRole(e){
      e.preventDefault();
      const axios = require("axios");
      var url = "/employees/role";
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      var role_form = document.getElementById("role_form");
      console.log(role_form)
      var data = new FormData(role_form);
      axios.post( url, data, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
      .then((response)=>{
        console.log(response)
         });
    },
    update(e) {
      e.preventDefault();
      const axios = require("axios");
      var url = "/api/packages";
      let csrf = document
        .querySelector("meta[name='csrf-token']")
        .getAttribute("content");
      var package_form = document.getElementById("submitNewPackage");
      var data = new FormData(package_form);
      axios
        .post(url, data, {
          headers: { "Content-Type": "text/csv", "x-csrf-token": csrf }
        })
        .then(response => {
         });
    }
  },
  computed: {
    packageExists() {
      return this.value.packages.length > 0;
    }
  },
  mounted(){
   if (this.value.account_number){
     this.accountExists = true
   }
    if (this.accountUpdated == true){
      this.accountTab  = true;
      this.profileTab  = false;
    }
    console.log("this.value")
    console.log(this.value)
   }
  
  };
</script>
<style scoped>

</style>
